%define	_root_sbindir	/sbin
%define	_root_libdir	/%{_lib}

Summary: Utilities for managing the fourth extended (ext4) filesystem
Name: e4fsprogs
Version: 1.41.12
Release: 2%{?dist}
# License based on upstream-modified COPYING file,
# which clearly states "V2" intent.
License: GPLv2
Group: System Environment/Base
Source0: http://downloads.sourceforge.net/e2fsprogs/e2fsprogs-%{version}.tar.gz
Source1: ext2_types-wrapper.h
Source2: blkid_types-wrapper.h
Source3: uuidd.init
Patch1: e2fsprogs-1.38-etcblkid.patch
Patch2: e2fsprogs-1.40.4-sb_feature_check_ignore.patch
Patch3: e4fsprogs-1.41.4-semi-statics
Patch4: e4fsprogs-1.41.4-install-as-e4fsprogs
Patch5: e4fsprogs-1.41.4-fix-lang
Patch6: e4fsprogs-1.41.4-name_updates
Patch7: e4fsprogs-1.41.4-install-libs-as-e4fsprogs
Patch8: e4fsprogs-1.41.12-EOFBLOCKS-test.patch
Patch9: e4fsprogs-1.41.12-relax-resize2fs-P.patch

Url: http://e2fsprogs.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: device-mapper
BuildRequires: pkgconfig, texinfo, libselinux-devel
BuildRequires: libsepol-devel, device-mapper, util-linux

%description
The e4fsprogs package contains a number of utilities for creating,
checking, modifying, and correcting any inconsistencies in the
fourth extended (ext4) filesystem. E4fsprogs contains
e4fsck (used to repair filesystem inconsistencies after an unclean
shutdown), mke4fs (used to initialize a partition to contain an
empty ext4 filesystem), debugfs (used to examine the internal
structure of a filesystem, to manually repair a corrupted
filesystem, or to create test cases for e4fsck), tune4fs (used to
modify filesystem parameters), and most of the other core ext4fs
filesystem utilities.

Please note that "e4fsprogs" simply contains renamed static binaries
from the equivalent upstream e2fsprogs release; it is packaged this
way for Red Hat Enterprise Linux 5 to ensure that the many changes
included for ext4 do not destabilize the core e2fsprogs in RHEL5.

You should install the e4fsprogs package if you need to manage the
performance of an ext4 filesystem.

%package libs
Summary: Ext4 filesystem-specific static libraries and headers
Group: Development/Libraries
Prereq: /sbin/ldconfig

%description libs
e4fsprogs-libs contains the libraries of the e4fsprogs package.

%package devel
Summary: Ext4 filesystem-specific static libraries and headers
Group: Development/Libraries
Requires: e4fsprogs-libs = %{version}-%{release}
Prereq: /sbin/install-info

%description devel
E4fsprogs-devel contains the libraries and header files needed to
develop fourth extended (ext4) filesystem-specific programs.

You should install e4fsprogs-devel if you want to develop ext4
filesystem-specific programs. If you install e4fsprogs-devel, you'll
also want to install e4fsprogs.

%prep
%setup -q -n e2fsprogs-%{version}
# put blkid.tab in /etc/blkid/
%patch1 -p1 -b .etcblkid
# ignore some flag differences on primary/backup sb feature checks
# mildly unsafe but 'til I get something better, avoid full fsck
# after an selinux install...
%patch2 -p1 -b .featurecheck
%patch3 -p1 -b .statics
%patch4 -p1 -b .toolnames
%patch5 -p1 -b .lang
%patch6 -p1 -b .namerefs
%patch7 -p1 -b .libnames
%patch8 -p1 -b .eofblocks
%patch9 -p1 -b .resize2fs

%build
%configure --enable-elf-shlibs --enable-nls --disable-e2initrd-helper
ln -s $RPM_BUILD_DIR/e2fsprogs-%{version}/lib/ext2fs $RPM_BUILD_DIR/e2fsprogs-%{version}/lib/ext4fs
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
export PATH=/sbin:$PATH
make install install-libs DESTDIR=$RPM_BUILD_ROOT INSTALL="%{__install} -p" \
	root_sbindir=%{_root_sbindir} root_libdir=%{_root_libdir}

# Libs we don't ship
rm -rf $RPM_BUILD_ROOT/%{_root_libdir}/libblkid.*
rm -rf $RPM_BUILD_ROOT/%{_libdir}/libblkid.*
rm -rf $RPM_BUILD_ROOT/%{_root_libdir}/libcom_err.*
rm -rf $RPM_BUILD_ROOT/%{_libdir}/libcom_err.*
rm -rf $RPM_BUILD_ROOT/%{_root_libdir}/libss.*
rm -rf $RPM_BUILD_ROOT/%{_libdir}/libss.*
rm -rf $RPM_BUILD_ROOT/%{_root_libdir}/libuuid.*
rm -rf $RPM_BUILD_ROOT/%{_libdir}/libuuid.*

# Headers we don't ship
rm -rf $RPM_BUILD_ROOT/%{_includedir}/blkid
rm -rf $RPM_BUILD_ROOT/%{_includedir}/et
rm -rf $RPM_BUILD_ROOT/%{_includedir}/uuid
rm -rf $RPM_BUILD_ROOT/%{_includedir}/ss

# And their man pages
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man1/compile_et.1*
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man1/mk_cmds.1*
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man3/com_err.3*
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man3/libblkid.3*
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man3/uuid*

# And other misc stuff
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/blkid.pc
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/et.pc
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/uuid.pc
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/ss.pc
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/com_err.pc
rm -rf $RPM_BUILD_ROOT/%{_datadir}/et
rm -rf $RPM_BUILD_ROOT/%{_datadir}/ss
rm -rf $RPM_BUILD_ROOT/%{_bindir}/compile_et
rm -rf $RPM_BUILD_ROOT/%{_bindir}/mk_cmds

# ugly hack to allow parallel install of 32-bit and 64-bit -devel packages:
mv -f $RPM_BUILD_ROOT%{_includedir}/ext4fs/ext2_types.h \
      $RPM_BUILD_ROOT%{_includedir}/ext4fs/ext2_types-%{_arch}.h
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_includedir}/ext4fs/ext2_types.h

%find_lang %{name}

%check
make check

%clean
rm -rf $RPM_BUILD_ROOT/%{buildroot}

%files -f %{name}.lang
%defattr(-,root,root)
%doc README RELEASE-NOTES

%config(noreplace) /etc/mke4fs.conf
%{_root_sbindir}/debuge4fs
%{_root_sbindir}/dumpe4fs
%{_root_sbindir}/e4fsck
%{_root_sbindir}/fsck.ext4
%{_root_sbindir}/fsck.ext4dev
%{_root_sbindir}/e4image
%{_root_sbindir}/e4label
%{_root_sbindir}/mke4fs
%{_root_sbindir}/finde4fs
%{_root_sbindir}/mkfs.ext4
%{_root_sbindir}/mkfs.ext4dev
%{_root_sbindir}/resize4fs
%{_root_sbindir}/tune4fs
%{_root_sbindir}/e4undo

%{_mandir}/man5/e4fsck.conf.5*
%{_mandir}/man5/mke4fs.conf.5*

%{_mandir}/man8/debuge4fs.8*
%{_mandir}/man8/dumpe4fs.8*
%{_mandir}/man8/e4fsck.8*
%{_mandir}/man8/fsck.ext4.8*
%{_mandir}/man8/fsck.ext4dev.8*
%{_mandir}/man8/e4image.8*
%{_mandir}/man8/e4label.8*
%{_mandir}/man8/mke4fs.8*
%{_mandir}/man8/mkfs.ext4.8*
%{_mandir}/man8/mkfs.ext4dev.8*
%{_mandir}/man8/resize4fs.8*
%{_mandir}/man8/tune4fs.8*
%{_mandir}/man8/e4undo.8*

%files libs
%defattr(-,root,root)
%{_root_libdir}/libe4p.so.*
%{_root_libdir}/libext4fs.so.*

%files devel
%defattr(-,root,root)
%{_infodir}/libext4fs.info*

%{_libdir}/libe4p.a
%{_libdir}/libe4p.so
%{_libdir}/libext4fs.a
%{_libdir}/libext4fs.so
%{_libdir}/pkgconfig/*.pc

%{_includedir}/e4p
%{_includedir}/ext4fs

%changelog
* Mon Oct 18 2010 Eric Sandeen <sandeen@redhat.com> 1.41.12-2
- Relax resize2fs -P requirements (#643945)
- Replace more e2fsck text with e4fsck

* Wed Jun 16 2010 Eric Sandeen <sandeen@redhat.com> 1.41.12-1
- Rebase to upstream (#604809)

* Tue Dec 15 2009 Eric Sandeen <sandeen@redhat.com> 1.41.9-3
- Fix up headers for multilib install

* Tue Nov 10 2009 Eric Sandeen <sandeen@redhat.com> 1.41.9-2
- Fix "make check" failure on ppc

* Tue Nov 10 2009 Eric Sandeen <sandeen@redhat.com> 1.41.9-1
- Update to e4fsprogs-1.41.9 (#528055)
- Add ext4-capable, renamed libraries & headers for pygrub (#524611)

* Tue Jul 14 2009 Eric Sandeen <sandeen@redhat.com> 1.41.5-3
- Fix more libext2fs bugs affecting resize (#510539)

* Tue Jun 02 2009 Eric Sandeen <sandeen@redhat.com> 1.41.5-2
- Fix log replay & resize corruption cases (#503562)

* Fri Apr 24 2009 Eric Sandeen <sandeen@redhat.com> 1.41.5-1
- New upstream release

* Fri Feb 13 2009 Eric Sandeen <sandeen@redhat.com> 1.41.4-2
- A couple bugfixes on top of new release (#482894, #481620)

* Fri Feb 13 2009 Eric Sandeen <sandeen@redhat.com> 1.41.4-1
- New upstream release

* Fri Sep 12 2008 Eric Sandeen <sandeen@redhat.com> 1.41.1-2
- Bump release for build system user error

* Fri Sep 12 2008 Eric Sandeen <sandeen@redhat.com> 1.41.1-1
- New upstream release

* Thu Jul 10 2008 Eric Sandeen <sandeen@redhat.com> 1.41.0-1
- New upstream release

* Mon Jul 07 2008 Eric Sandeen <sandeen@redhat.com> 1.41-0.4.WIP.0707
- New upstream snapshot release

* Fri Jun 20 2008 Eric Sandeen <esandeen@redhat.com> 1.41-0.3.WIP.0617
- Apply patch which changes name references within tools

* Fri Jun 20 2008 Eric Sandeen <esandeen@redhat.com> 1.41-0.2.WIP.0617
- "e4fsprogs" build of e2fsprogs-1.41-WIP-0617

* Fri May 23 2008 Eric Sandeen <esandeen@redhat.com> 1.40.10-1
- New upstream version

* Mon May 12 2008 Eric Sandeen <esandeen@redhat.com> 1.40.9-2
- Fix blkid swap recognition on big-endian boxes (#445786)

* Sun Apr 27 2008 Eric Sandeen <esandeen@redhat.com> 1.40.9-1
- New upstream version

* Fri Mar 14 2008 Eric Sandeen <esandeen@redhat.com> 1.40.8-2
- Update ext2fs_swap_inode_full() fix to match upstream
- Check more of swapv1 header in blkid detection (#442937)

* Fri Mar 14 2008 Eric Sandeen <esandeen@redhat.com> 1.40.8-1
- New upstream version

* Mon Mar 03 2008 Eric Sandeen <esandeen@redhat.com> 1.40.7-2
- second try at fixing resize2fs vs. large inodes... (#434893)

* Fri Feb 29 2008 Eric Sandeen <esandeen@redhat.com> 1.40.7-1
- New upstream version, special leap-day edition
- Fix resize2fs losing inline xattrs when shrinking (#434893)
  and add patch to fix swap_inode_full in this case
- Allow mke2fs & tune2fs to manipulate large_file feature (#258381)
- Handle lvm error conditions in libblkid (#433857)
- Allow tune2fs to clear the resize_inode feature (#167816)
- Teach blkid to detect LVM2 physical volumes (#409321)
- Show "mostly printable" xattrs as text in debugfs (#430621)
- Trimmed pre-1.38 rpm changelog entries

* Sun Feb 10 2008 Eric Sandeen <esandeen@redhat.com> 1.40.6-1
- New upstream version

* Fri Feb 08 2008 Eric Sandeen <esandeen@redhat.com> 1.40.5-2
- gcc-4.3 rebuild

* Mon Jan 28 2008 Eric Sandeen <esandeen@redhat.com> 1.40.5-1
- New upstream version, drop several now-upstream patches.

* Thu Jan 24 2008 Eric Sandeen <sandeen@redhat.com> 1.40.4-7
- Fix sb flag comparisons properly this time (#428893)
- Make 256-byte inodes for the [default] mkfs case.
  This will facilitate upgrades to ext4 later, and help xattr perf.

* Wed Jan 23 2008 Eric Sandeen <sandeen@redhat.com> 1.40.4-6
- Completely clobber e2fsck.static build.

* Wed Jan 23 2008 Eric Sandeen <sandeen@redhat.com> 1.40.4-5
- Ignore some primary/backup superblock flag differences (#428893)
- Teach libblkid about ext4dev.

* Mon Jan 10 2008 Eric Sandeen <sandeen@redhat.com> 1.40.4-4
- Build e2fsck as a dynamically linked binary.
- Re-fix uidd manpage default paths.

* Tue Jan 09 2008 Eric Sandeen <sandeen@redhat.com> 1.40.4-3
- New uuidd subpackage, and properly set up uuidd at install.

* Tue Jan 01 2008 Eric Sandeen <esandeen@redhat.com> 1.40.4-2
- Add new uidd files to specfile

* Tue Jan 01 2008 Eric Sandeen <esandeen@redhat.com> 1.40.4-1
- New upstream version, drop several now-upstream patches.

* Tue Jan 01 2008 Eric Sandeen <esandeen@redhat.com> 1.40.2-15
- Drop resize_inode removal patch from tune2fs; ostensibly was
  for old kernels which could not mount, but seems to be fine.
- Drop pottcdate removal patch, and don't rebuild .po files,
  causes multilib problems and we generally shouldn't rebuild.
- Drop multilib patch; wrapper header should take care of this now.
- Drop ->open rename, Fedora seems ok with this now.

* Tue Dec 11 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-14
- Fix integer overflows (#414591 / CVE-2007-5497)

* Tue Dec  4 2007 Stepan Kasal <skasal@redhat.com> 1.40.2-13
- The -devel package now requires device-mapper-devel, to match
  the dependency in blkid.pc (#410791)

* Tue Nov 27 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-12
- Use upstream patch for blkid fat detection, avoids div-by-zero
  when encountering some BSD partitions (#398281)

* Tue Oct 23 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-11
- Add arm to multilib header wrapper

* Sat Oct 20 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-10
- Make (more) file timestamps match those in tarball for multilib tidiness 
- Fix e2fsprogs-libs summary (shared libs not static)

* Tue Oct 15 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-9
- Detect big-endian squashfs filesystems in libblkid (#305151)

* Tue Oct 02 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-8
- Detect squashfs filesystems in libblkid (#305151)

* Tue Sep 18 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-7
- Fix blkid fat probe when there is a real MBR (#290951)

* Tue Sep 18 2007 Oliver Falk <oliver@linux-kernel.at> 1.40.2-6
- Add alpha to the header wrappers 

* Fri Sep 07 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-5
- wrap a couple headers to fix multilib issues (#270441)

* Wed Aug 29 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-4
- add gawk to e2fsprogs-devel Requires, compile_et needs it (#265961)

* Thu Aug 23 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-3
- Update license tags
- Fix one open-create caller with no mode
- Protect ->open ops from glibc open-create-mode-checker
- Fix source URL
- Add gawk to BuildRequires

* Wed Jul 18 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-2
- Fix bug in ext2fs_swap_inode_full() on big-endian boxes

* Tue Jul 17 2007 Eric Sandeen <esandeen@redhat.com> 1.40.2-1
- New version 1.40.2
- Fix up warning in badblocks

* Mon Jun 25 2007 Eric Sandeen <esandeen@redhat.com> 1.39-15
- Fix up .po files to remove timestamps; multilib issues (#245653)

* Fri Jun 22 2007 Eric Sandeen <esandeen@redhat.com> 1.39-14
- Many coverity-found potential leaks, segfaults, etc (#239354)
- Fix debugfs segfaults when no fs open (#208416, #209330)
- Avoid recursive loops in logdump due to symlinks in /dev (#210371)
- Don't write changes to the backup superblocks by default (#229561)
- Correct byteswapping for fast symlinks with xattrs (#232663)
- e2fsck: added sanity check for xattr validation (#230193)

* Wed Jun 20 2007 Eric Sandeen <esandeen@redhat.com> 1.39-13
- add dist tag to release field

* Wed Jun 20 2007 Eric Sandeen <esandeen@redhat.com> 1.39-12
- add LUKS support to libblkid (#242421)

* Fri Feb 23 2007 Karsten Hopp <karsten@redhat.com> 1.39-11
- fix post/preun requirements
- use smp flags

* Mon Feb 05 2007 Alasdair Kergon <agk@redhat.com> - 1.39-10
- Add build dependency on new device-mapper-devel package.

* Mon Dec 25 2006 Thomas Woerner <twoerner@redhat.com> - 1.39-9
- build fixes for new automake 1.10 (#220715)

* Mon Dec 18 2006 Thomas Woerner <twoerner@redhat.com> - 1.39-8
- make uuid_generate_time generate unique uuids (#218606)

* Wed Sep 20 2006 Jarod Wilson <jwilson@redhat.com> - 1.39-7
- 32-bit 16T fixups from esandeen (#202807)
- Update summaries and descriptions

* Sun Sep 17 2006 Karel Zak <kzak@redhat.com> - 1.39-6
- Fix problem with empty FAT label (#206656)

* Tue Sep  5 2006 Peter Jones <pjones@redhat.com> - 1.39-5
- Fix memory leak in device probing.

* Mon Jul 24 2006 Thomas Woerner <twoerner@redhat.com> - 1.39-4
- fixed multilib devel conflicts (#192665)

* Thu Jul 20 2006 Bill Nottingham <notting@redhat.com> - 1.39-3
- prevent libblkid returning /dev/dm-X

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1.39-2.1
- rebuild

* Mon Jul 10 2006 Karel Zak <kzak@redhat.com> - 1.39-2
- add GFS abd GFS2 support to libblkid

* Thu Jul  6 2006 Thomas Woerner <twoerner@redhat.com> - 1.39-1
- new version 1.39
- dropped ext2online, because resize2fs is now able to do online resize
- spec file cleanup
- enabled checks for build

